#define RDS_TITLE     "MAXTOP"                  /*  Program Name      */
#ifdef __OS2__
  #undef  RDS_TITLE
  #define RDS_TITLE   "MAXTOPP"                 /*  Program Name      */
#endif
#define RDS_DATES     "1995"                    /*  Copyright Date    */
#define RDS_VERSION   "1.30"                    /*  Version Number    */
#define NUM_TO_LIST   15                        /*  List Top n Users  */
#define NUM_EX_PRIV   10                        /*  Exclude n Privs   */
#define NUM_EX_NAME   10                        /*  Exclude n Names   */
/*

                              MAXTOP / MAXTOPP
             Copyright (c) Bob Swift, 1995.  All Rights Reserved.

   This program is used to read the Max 3.00 USER.BBS file and generate a
   file listing the top users (upload, download, calls) for the BBS.  The
   first record in USER.BBS (usually the sysop) is ignored.

   The program is based on an example program included with the Maximus
   User Language (MUL) package for use with Maximus 2.x, which is
   Copyright (c) by CodeLand Australia.

   The format for using this program is as follows:

                MAXTOP  [ctlfile]            (for DOS)
                MAXTOPP [ctlfile]            (for OS/2)

   Where [ctlfile] is the path and name of the control file (default is
                   MAXTOP.CTL in the current directory).

   Examples:        MAXTOP  c:\max\misc\topuser.cfg
                    MAXTOPP ctlfiles\maxtop.ctl
                    MAXTOPP

   The program will display a VERY brief set of instructions if it encounters
   an error.  The following is a list of the error codes returned by the
   program:

                  0 - No errors.  Normal termination.
                  1 - Bad / Extra command line argument.
                  2 - Unable to open the control file.
                  3 - Unable to read the input file.
                  4 - Unable to write the output file.
                  5 - No user records to process.

   When an error is encountered, the program will exit immediately and will
   attempt to properly close all files.

   Although I have chosen to retain all rights to this program, you are free
   to use it under the following conditions:

            - You realize that there is NO Warrantee of any sort.
              It was tested pretty thoroughly here before release
              but who knows what bugs may be lurking within.

            - You will not modify the code and release a new version
              of the program.  I welcome suggestions for improvement
              (especially when accompanied by code) but I make no
              guarantee of future releases.

            - You drop me a note to let me know that you use the
              program.  That way, I know who to inform if there are
              any future releases.  Please either send netmail to:

                        Bob Swift
                        1:342/5 @ fidonet

              or a postcard to:

                        Bob Swift
                        5708 - 47th Street
                        Stony Plain, Alberta
                        T7Z 1C6, Canada

            - If you find the program useful, I ask that you do
              something to brighten somebody else's day.  Just
              exactly what, I will leave up to you.

   You may freely distribute this program provided that you distribute only
   the complete archive which includes the files:

        MAXTOP.EXE      -   Program File for DOS
        MAXTOPP.EXE     -   Program File for OS/2
        MAXTOP.CTL      -   Sample Control File
        MAXTOP.C        -   'C' Source Code
        MAX_U.H         -   Maximus User Structures
        STAMP.H         -   Maximus Stamp Structures
        TYPEDEFS.H      -   Maximus Type Definitions
        MAXTOP.DOC      -   Program Documentation
        FILE_ID.DIZ     -   Program Description File

   If you run across any bugs with this program, please report them to the
   address listed above.  Thanks for giving MAXTOP(P) a try.


                                                   Bob Swift (1:342/5)


   Revision History
   ----------------

   1.00     95/09/02    First release version.

   1.01     95/09/04    Fixed a (stupid) bug that would only display a
                        partial top users list if the user file was
                        specified on the command line.  Thanks Tom.

   1.10     95/09/06    Revised to allow options to be changed via a
                        control file.

   1.11     95/09/09    Corrected a bug that would screw up the report
                        format if a long user name was encountered.  The
                        program now truncates long names.

   1.20     95/09/10    Revised to allow user selection of any combination
                        of up to three top user criteria.  Available
                        criteria are Calls, Downloads, Uploads and
                        Messages Written.  Output format is automatically
                        adjusted to fit the number of report criteria
                        selected.

   1.30     95/11/25    Added option to display users' first call dates at
                        request of Dallas Hinton (1:153/715).  Added option
                        to exclude selected user names at request of Thomas
                        Hedberg (2:234/73), and selected privilege levels
                        at request of Myles Bunbury (1:163/114).  Added
                        option to select number of top users to display,
                        between 1 and 15.


*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#ifdef __OS2__
  #include <os2.h>
#endif
#include "max_u.h"

#define BLACK           "\x16\x01\x00"
#define BLUE            "\x16\x01\x01"
#define GREEN           "\x16\x01\x02"
#define CYAN            "\x16\x01\x03"
#define RED             "\x16\x01\x04"
#define MAGENTA         "\x16\x01\x05"
#define BROWN           "\x16\x01\x06"
#define GRAY            "\x16\x01\x07"
#define GREY            "\x16\x01\x07"
#define LBLACK          "\x16\x01\x08"
#define LBLUE           "\x16\x01\x09"
#define LGREEN          "\x16\x01\x0a"
#define LCYAN           "\x16\x01\x0b"
#define LRED            "\x16\x01\x0c"
#define LMAGENTA        "\x16\x01\x0d"
#define YELLOW          "\x16\x01\x0e"
#define WHITE           "\x16\x01\x0f"

#define COLOURHEAD      "\x16\x01\x0f"
#define COLOURHUND      "\x16\x01\x0c"
#define COLOURBOXB      "\x16\x01\x03"
#define COLOURLABL      "\x16\x01\x1b"
#define COLOUROPT1      "\x16\x01\x0e"
#define COLOUROPT2      "\x16\x01\x0a"
#define COLOUROPT3      "\x16\x01\x0c"
#define COLOURDATA      "\x16\x01\x07"
#define COLOURFOOT      "\x16\x01\x02"

void helpscrn(int ernum);


/*******************************************************************/

void main(int argc, char *argv[])
{

struct tm tm_now;
struct tm *tm_info;
time_t secs_now;

FILE *infile1,*outfile;

char temp[256];
char temp1[256];
char temp2[256];
char temp3[256];
char *p,*p1,*p2,*p3;
char *line=  "                 \r\n";
char *b1 =   "Ŀ\r\n";
char *c1 =   "Ĵ\r\n";
char *d1 =   "Ĵ\r\n";
char *e1 =   "\r\n";

char *s_check;

static struct _usr max_data;

word i,j,k,l,numtolist,skip_flag;
word f_uf,f_ua,f_cf,f_ca,f_ea,f_fc,f_ep,f_en;
word c_c,c_d,c_m,c_u;

char c_name[3][NUM_TO_LIST][36];

char e_name[NUM_EX_NAME][36];
word e_priv[NUM_EX_PRIV];

dword c_call[NUM_TO_LIST];
dword c_fc[2][NUM_TO_LIST];

SCOMBO usr_time;

dword c_num[3][NUM_TO_LIST];         /* number */

word c_index[3][NUM_TO_LIST];

numtolist = min(NUM_TO_LIST,10);

printf("\n\n%s (v%s)\n",RDS_TITLE,RDS_VERSION);
printf("Copyright (c) Bob Swift, %s.  All Rights Reserved.",RDS_DATES);

if (argc > 2) helpscrn(1);

strcpy(temp1,"MAXTOP.CTL");                               /* Control File  */
if (argc == 2) strcpy(temp1,strupr(argv[1]));             /* Control File  */

if ((infile1=fopen(temp1,"rt")) == NULL) helpscrn(2);

f_uf = 0;
f_ua = 0;
f_cf = 0;
f_ca = 0;
f_ea = 0;
f_fc = 0;
f_ep = 0;
f_en = 0;
c_c = 0;
c_d = 0;
c_m = 0;
c_u = 0;
temp1[0] = '\0';
strcpy(temp2,"MAXTOP.BBS");

while (fgets(temp3,256,infile1) != NULL)
  {
  strcpy(temp,temp3);

/*********************************************************
*                                                        *
*  The following routine is used to pull the tokens out  *
*  of the input string from the control file.  This is   *
*  being used rather than the strtok() function because  *
*  of a problem with the strtok() function in the OS/2   *
*  version compiled with the Watcom C/C++ compiler.      *
*                                                        *
*********************************************************/

  l = 0;
  p = temp;
  p1 = p;
  p2 = p;
  p3 = p;
  k = 0;
  i = 0;
  j = strlen(temp);
  while (i < j)
    {
    if ((temp[i] == ' ') || (temp[i] == '\t') || (temp[i] == '\n'))
      {
      if (k != 0)
        {
        k = 0;
        temp[i] = '\0';
        if (l == 1) i = j;
        }
      if (p == p3) p++;
      if (p1 == p3) p1++;
      if (p2 == p3) p2++;
      if (l == 0) p3++;
      }
    else
      {
      if (k == 0)
        {
        k = 1;
        if (p == p3)
          {p1++; p2++; p3++;}
        else
          {
          if (p1 == p3)
            {p2++; p3++;}
          else
            {
            if (p2 == p3)
              p3++;
            else
              l = 1;
            }
          }
        }
      else
        {
        if (p == p3) p++;
        if (p1 == p3) p1++;
        if (p2 == p3) p2++;
        if (l == 0) p3++;
        }
      }
    i++;
    }

/************************************
*                                   *
*  End of special parsing routine.  *
*                                   *
************************************/

  if (strcmpi(p,"USEFIRST") == 0) f_uf = 1;
  if (strcmpi(p,"CLSFIRST") == 0) f_cf = 1;
  if (strcmpi(p,"CLSAFTER") == 0) f_ca = 1;
  if (strcmpi(p,"ENTERAFTER") == 0) f_ea = 1;
  if (strcmpi(p,"ALIAS") == 0) f_ua = 1;
  if (strcmpi(p,"FIRSTCALL") == 0) f_fc = 1;
  if (strcmpi(p,"DISPLAY") == 0)
    {
//    p1 = strtok(NULL," \n");
//    if (p1 != NULL)
    if ((p1[0] != '\0') && (p1[0] != ';'))
      {
      i = (word) atoi(p1);
      if ((i <= NUM_TO_LIST) && (i > 0)) numtolist = i;
      }
    }
  if (strcmpi(p,"EXCLUDEPRIV") == 0)
    {
//    p1 = strtok(NULL," \n");
//    if (p1 != NULL)
    if ((p1[0] != '\0') && (p1[0] != ';') && (f_ep < NUM_EX_PRIV))
      {
      e_priv[f_ep] = (word) atoi(p1);
      f_ep++;
      }
    }
  if (strcmpi(p,"EXCLUDENAME") == 0)
    {
//    p1 = strtok(NULL," \n");
//    if (p1 != NULL)
    if ((p1[0] != '\0') && (p1[0] != ';') && (f_en < NUM_EX_NAME))
      {
      p1[35] = '\0';
      strcpy(e_name[f_en],p1);
      i = strlen(p1);
      while (i > 0)
        {
        i--;
        if (e_name[f_en][i] == '_') e_name[f_en][i] = ' ';
        }
      f_en++;
      }
    }
  if (strcmpi(p,"OUTPUT") == 0)
    {
//    p1 = strtok(NULL," \n");
//    if (p1 != NULL)
    if ((p1[0] != '\0') && (p1[0] != ';'))
      {
      strcpy(temp2,p1);
      }
    else
      {
      strcpy(temp2,"MAXTOP.BBS");
      }
    }
  if (strcmpi(p,"USERPATH") == 0)
    {
//    p1 = strtok(NULL," \n");
//    if (p1 != NULL)
    if ((p1[0] != '\0') && (p1[0] != ';'))
      {
      strcpy(temp1,p1);
      }
    else
      {
      temp1[0] = '\0';
      }
    }
  if (strcmpi(p,"CATEGORY") == 0)
    {
    c_c = 0;
    c_d = 0;
    c_m = 0;
    c_u = 0;
    if (((p1[0] == 'C') || (p1[0] == 'c')) && (c_c == 0)) c_c = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p1[0] == 'D') || (p1[0] == 'd')) && (c_d == 0)) c_d = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p1[0] == 'M') || (p1[0] == 'm')) && (c_m == 0)) c_m = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p1[0] == 'U') || (p1[0] == 'u')) && (c_u == 0)) c_u = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p2[0] == 'C') || (p2[0] == 'c')) && (c_c == 0)) c_c = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p2[0] == 'D') || (p2[0] == 'd')) && (c_d == 0)) c_d = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p2[0] == 'M') || (p2[0] == 'm')) && (c_m == 0)) c_m = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p2[0] == 'U') || (p2[0] == 'u')) && (c_u == 0)) c_u = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p3[0] == 'C') || (p3[0] == 'c')) && (c_c == 0)) c_c = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p3[0] == 'D') || (p3[0] == 'd')) && (c_d == 0)) c_d = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p3[0] == 'M') || (p3[0] == 'm')) && (c_m == 0)) c_m = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    if (((p3[0] == 'U') || (p3[0] == 'u')) && (c_u == 0)) c_u = (c_c > 0) + (c_d > 0) + (c_m > 0) + (c_u > 0) + 1;
    }
  }
fclose(infile1);

if (c_c + c_d + c_m + c_u == 0)
  {
  c_c = 1;
  c_d = 2;
  }

if (f_fc == 1)
  {
  if (c_c > 2) c_c = 0;
  if (c_d > 2) c_d = 0;
  if (c_m > 2) c_m = 0;
  if (c_u > 2) c_u = 0;
  }

if (temp1[0] != '\0')
  {
  if (temp1[strlen(temp1)-1] != ':' && temp1[strlen(temp1)-1] != '\\')
    strcat(temp1,"\\");
  }

strcat(temp1,"USER.BBS");

if ((infile1=fopen(temp1,"rb")) == NULL) helpscrn(3);
if ((outfile=fopen(temp2,"wb")) == NULL) helpscrn(4);

printf("\n\nInitializing.");

i = 0;

while (i < numtolist)
    {
    c_index[0][i] = i;
    c_index[1][i] = i;
    c_index[2][i] = i;
    c_name[0][i][0] = '\0';
    c_name[1][i][0] = '\0';
    c_name[2][i][0] = '\0';
    c_num[0][i] = 0;
    c_num[1][i] = 0;
    c_num[2][i] = 0;
    i++;
    }

printf("\n");

i = 0;

while (fread(&max_data,sizeof(struct _usr),1,infile1) == 1)
{
  i++;
  printf("\rProcessing User: %d",i);

  skip_flag = 0;
  j = 0;
  while ((j < f_en) && (skip_flag == 0))
    {
    if (strcmpi(e_name[j],max_data.name) == 0) skip_flag = 1;
    if (strcmpi(e_name[j],max_data.alias) == 0) skip_flag = 1;
    j++;
    }
  j = 0;
  while ((j < f_ep) && (skip_flag == 0))
    {
    if (e_priv[j] == max_data.priv) skip_flag = 1;
    j++;
    }

  if (((i > 1) || (f_uf == 1)) && (skip_flag == 0))
    {
    j = 0;
    while (j < numtolist)
        {
        if ((c_c > 0) && ((dword) max_data.times > c_num[c_c-1][c_index[c_c-1][j]]))
            {
            strcpy(c_name[c_c-1][c_index[c_c-1][numtolist-1]],max_data.name);
            if (f_ua == 1) strcpy(c_name[c_c-1][c_index[c_c-1][numtolist-1]],max_data.alias);
            if (f_fc == 1)
              {
              c_fc[c_c-1][c_index[c_c-1][numtolist-1]] = max_data.date_1stcall.ldate;
              if (c_fc[c_c-1][c_index[c_c-1][numtolist-1]] == 0) c_fc[c_c-1][c_index[c_c-1][numtolist-1]] = max_data.date_pwd_chg.ldate;
              }
            c_call[c_index[c_c-1][numtolist-1]] = max_data.ludate.ldate;
            c_num[c_c-1][c_index[c_c-1][numtolist-1]] = (dword) max_data.times;
            l = c_index[c_c-1][numtolist-1];
            k = numtolist - 1;
            while (k > j)
                {
                c_index[c_c-1][k] = c_index[c_c-1][k-1];
                k--;
                }
            c_index[c_c-1][j] = l;
            j = numtolist;
            }
        j++;
        }
    }

  if (((i > 1) || (f_uf == 1)) && (skip_flag == 0))
    {
    j = 0;
    while (j < numtolist)
        {
        if ((c_d > 0) && (max_data.down > c_num[c_d-1][c_index[c_d-1][j]]))
            {
            strcpy(c_name[c_d-1][c_index[c_d-1][numtolist-1]],max_data.name);
            if (f_ua == 1) strcpy(c_name[c_d-1][c_index[c_d-1][numtolist-1]],max_data.alias);
            if (c_d == 1) c_call[c_index[0][numtolist-1]] = max_data.ludate.ldate;
            if (f_fc == 1)
              {
              c_fc[c_d-1][c_index[c_d-1][numtolist-1]] = max_data.date_1stcall.ldate;
              if (c_fc[c_d-1][c_index[c_d-1][numtolist-1]] == 0) c_fc[c_d-1][c_index[c_d-1][numtolist-1]] = max_data.date_pwd_chg.ldate;
              }
            c_num[c_d-1][c_index[c_d-1][numtolist-1]] = max_data.down;
            l = c_index[c_d-1][numtolist-1];
            k = numtolist - 1;
            while (k > j)
                {
                c_index[c_d-1][k] = c_index[c_d-1][k-1];
                k--;
                }
            c_index[c_d-1][j] = l;
            j = numtolist;
            }
        j++;
        }
    }

  if (((i > 1) || (f_uf == 1)) && (skip_flag == 0))
    {
    j = 0;
    while (j < numtolist)
        {
        if ((c_u > 0) && (max_data.up > c_num[c_u-1][c_index[c_u-1][j]]))
            {
            strcpy(c_name[c_u-1][c_index[c_u-1][numtolist-1]],max_data.name);
            if (f_ua == 1) strcpy(c_name[c_u-1][c_index[c_u-1][numtolist-1]],max_data.alias);
            if (c_u == 1) c_call[c_index[0][numtolist-1]] = max_data.ludate.ldate;
            if (f_fc == 1)
              {
              c_fc[c_u-1][c_index[c_u-1][numtolist-1]] = max_data.date_1stcall.ldate;
              if (c_fc[c_u-1][c_index[c_u-1][numtolist-1]] == 0) c_fc[c_u-1][c_index[c_u-1][numtolist-1]] = max_data.date_pwd_chg.ldate;
              }
            c_num[c_u-1][c_index[c_u-1][numtolist-1]] = max_data.up;
            l = c_index[c_u-1][numtolist-1];
            k = numtolist - 1;
            while (k > j)
                {
                c_index[c_u-1][k] = c_index[c_u-1][k-1];
                k--;
                }
            c_index[c_u-1][j] = l;
            j = numtolist;
            }
        j++;
        }
    }

  if (((i > 1) || (f_uf == 1)) && (skip_flag == 0))
    {
    j = 0;
    while (j < numtolist)
        {
        if ((c_m > 0) && (max_data.msgs_posted > c_num[c_m-1][c_index[c_m-1][j]]))
            {
            strcpy(c_name[c_m-1][c_index[c_m-1][numtolist-1]],max_data.name);
            if (f_ua == 1) strcpy(c_name[c_m-1][c_index[c_m-1][numtolist-1]],max_data.alias);
            if (c_m == 1) c_call[c_index[0][numtolist-1]] = max_data.ludate.ldate;
            if (f_fc == 1)
              {
              c_fc[c_m-1][c_index[c_m-1][numtolist-1]] = max_data.date_1stcall.ldate;
              if (c_fc[c_m-1][c_index[c_m-1][numtolist-1]] == 0) c_fc[c_m-1][c_index[c_m-1][numtolist-1]] = max_data.date_pwd_chg.ldate;
              }
            c_num[c_m-1][c_index[c_m-1][numtolist-1]] = max_data.msgs_posted;
            l = c_index[c_m-1][numtolist-1];
            k = numtolist - 1;
            while (k > j)
                {
                c_index[c_m-1][k] = c_index[c_m-1][k-1];
                k--;
                }
            c_index[c_m-1][j] = l;
            j = numtolist;
            }
        j++;
        }
    }

}

if (i == 0)
    helpscrn(5);

fclose(infile1);

i = 35;
if (f_fc == 1) i = 28;
k = c_c + c_d + c_m + c_u;
if (k == 3)
  {
  i = 28;
  if (f_fc == 1) i = 16;
  b1[39] = '';
  c1[39] = '';
  d1[39] = '';
  }
if (k == 6)
  {
  i = 16;
  b1[26] = '';
  b1[52] = '';
  c1[26] = '';
  c1[52] = '';
  d1[26] = '';
  d1[52] = '';
  }
j = 0;
while (j < numtolist)
    {
    c_name[0][j][i] = '\0';
    c_name[1][j][i] = '\0';
    c_name[2][j][i] = '\0';
    j++;
    }

printf("\nWriting output file");

secs_now = time(NULL);

// Output CLS, MoreOff, heading and underline
if (f_cf == 1)
  {
  if (fputc(12,outfile) == EOF) helpscrn(4);
  }
if (fputc(11,outfile) == EOF) helpscrn(4);
strftime(temp1,77,"Maximus Top User Report as of %a, %Y %b %d",localtime(&secs_now));
sprintf(temp,"%77s"," ");
j = (strlen(temp) - strlen(temp1)) / 2 + 2;
i = 0;
while (temp1[i] != '\0')
  {
  temp[j] = temp1[i];
  j++;
  i++;
  }
if (fprintf(outfile,"%s%s\r\n",COLOURHEAD,temp) == EOF) helpscrn(4);
if (fprintf(outfile,"%s%s",COLOURHUND,line) == EOF) helpscrn(4);

strcpy(temp1+(c_c * 20),"CALLER");
strcpy(temp1+(c_d * 20),"DOWNLOADER");
strcpy(temp1+(c_m * 20),"MSG WRITER");
strcpy(temp1+(c_u * 20),"UPLOADER");
strcpy(temp2+(c_c * 20),"(Calls)");
strcpy(temp2+(c_d * 20),"(Kb)");
strcpy(temp2+(c_m * 20),"(Msgs)");
strcpy(temp2+(c_u * 20),"(Kb)");

// Output box top
if (fprintf(outfile,"%s%s",COLOURBOXB,b1) == EOF) helpscrn(4);

// Output box heading
if (k == 1)
  {
  if (f_fc == 1)
    {
    if (fprintf(outfile,"%s TOP %-29s(First Call)    (Last Call)%15s %s",COLOURLABL,(temp1+20),(temp2+20),COLOURBOXB) == EOF) helpscrn(4);
    }
  else
    {
    if (fprintf(outfile,"%s TOP %-41s(Last Call)%19s %s",COLOURLABL,(temp1+20),(temp2+20),COLOURBOXB) == EOF) helpscrn(4);
    }
  }
if (k == 3)
  {
  if (f_fc == 1)
    {
    if (fprintf(outfile,"%s TOP %-15s(Since)%10s %s",COLOURLABL,(temp1+20),(temp2+20),COLOURBOXB) == EOF) helpscrn(4);
    if (fprintf(outfile,"%s TOP %-15s(Since)%10s %s",COLOURLABL,(temp1+40),(temp2+40),COLOURBOXB) == EOF) helpscrn(4);
    }
  else
    {
    if (fprintf(outfile,"%s TOP %-20s%12s %s",COLOURLABL,(temp1+20),(temp2+20),COLOURBOXB) == EOF) helpscrn(4);
    if (fprintf(outfile,"%s TOP %-20s%12s %s",COLOURLABL,(temp1+40),(temp2+40),COLOURBOXB) == EOF) helpscrn(4);
    }
  }
if (k == 6)
  {
  if (fprintf(outfile,"%s TOP %-11s%8s %s",COLOURLABL,(temp1+20),(temp2+20),COLOURBOXB) == EOF) helpscrn(4);
  if (fprintf(outfile,"%s TOP %-11s%8s %s",COLOURLABL,(temp1+40),(temp2+40),COLOURBOXB) == EOF) helpscrn(4);
  if (fprintf(outfile,"%s TOP %-11s%8s %s",COLOURLABL,(temp1+60),(temp2+60),COLOURBOXB) == EOF) helpscrn(4);
  }

// Output box divider
if (fprintf(outfile,"\r\n%s",c1) == EOF) helpscrn(4);

// Output first data line
if (k == 1)
  {
  usr_time.ldate = c_call[c_index[0][0]];
  tm_now.tm_sec  = (int) usr_time.msg_st.time.ss;
  tm_now.tm_min  = (int) usr_time.msg_st.time.mm;
  tm_now.tm_hour = (int) usr_time.msg_st.time.hh;
  tm_now.tm_mday = (int) usr_time.msg_st.date.da;
  tm_now.tm_mon  = (int) usr_time.msg_st.date.mo - 1;
  tm_now.tm_year = (int) usr_time.msg_st.date.yr + 80;
  secs_now = mktime(&tm_now);
  tm_info = localtime(&secs_now);
  strftime(temp,80,"%Y %b %d  %H:%M:%S",tm_info);
  if (f_fc == 1)
    {
    strftime(temp,80,"%Y-%b-%d",tm_info);
    usr_time.ldate = c_fc[0][c_index[0][0]];
    tm_now.tm_sec  = (int) usr_time.msg_st.time.ss;
    tm_now.tm_min  = (int) usr_time.msg_st.time.mm;
    tm_now.tm_hour = (int) usr_time.msg_st.time.hh;
    tm_now.tm_mday = (int) usr_time.msg_st.date.da;
    tm_now.tm_mon  = (int) usr_time.msg_st.date.mo - 1;
    tm_now.tm_year = (int) usr_time.msg_st.date.yr + 80;
    secs_now = mktime(&tm_now);
    tm_info = localtime(&secs_now);
    strftime(temp1,80,"%Y-%b-%d",tm_info);
    if (fprintf (outfile," %s",COLOUROPT1) == EOF) helpscrn(4);
    if (fprintf (outfile,"%-34s%-15s%-16s%10lu %s\r\n",c_name[0][c_index[0][0]],temp1,temp,c_num[0][c_index[0][0]],COLOURBOXB) == EOF) helpscrn(4);
    }
  else
    {
    if (fprintf (outfile," %s",COLOUROPT1) == EOF) helpscrn(4);
    if (fprintf (outfile,"%-40s%-25s%10lu %s\r\n",c_name[0][c_index[0][0]],temp,c_num[0][c_index[0][0]],COLOURBOXB) == EOF) helpscrn(4);
    }
  }
if (k == 3)
  {
  if (f_fc == 1)
    {
    usr_time.ldate = c_fc[0][c_index[0][0]];
    tm_now.tm_sec  = (int) usr_time.msg_st.time.ss;
    tm_now.tm_min  = (int) usr_time.msg_st.time.mm;
    tm_now.tm_hour = (int) usr_time.msg_st.time.hh;
    tm_now.tm_mday = (int) usr_time.msg_st.date.da;
    tm_now.tm_mon  = (int) usr_time.msg_st.date.mo - 1;
    tm_now.tm_year = (int) usr_time.msg_st.date.yr + 80;
    secs_now = mktime(&tm_now);
    tm_info = localtime(&secs_now);
    strftime(temp,80,"%Y-%b-%d",tm_info);
    usr_time.ldate = c_fc[1][c_index[1][0]];
    tm_now.tm_sec  = (int) usr_time.msg_st.time.ss;
    tm_now.tm_min  = (int) usr_time.msg_st.time.mm;
    tm_now.tm_hour = (int) usr_time.msg_st.time.hh;
    tm_now.tm_mday = (int) usr_time.msg_st.date.da;
    tm_now.tm_mon  = (int) usr_time.msg_st.date.mo - 1;
    tm_now.tm_year = (int) usr_time.msg_st.date.yr + 80;
    secs_now = mktime(&tm_now);
    tm_info = localtime(&secs_now);
    strftime(temp1,80,"%Y-%b-%d",tm_info);
    if (fprintf (outfile," %s",COLOUROPT1) == EOF) helpscrn(4);
    if (fprintf (outfile,"%-17s%s%8lu %s %s",c_name[0][c_index[0][0]],temp,c_num[0][c_index[0][0]],COLOURBOXB,COLOUROPT2) == EOF) helpscrn(4);
    if (fprintf (outfile,"%-17s%s%8lu %s\r\n",c_name[1][c_index[1][0]],temp1,c_num[1][c_index[1][0]],COLOURBOXB) == EOF) helpscrn(4);
    }
  else
    {
    if (fprintf (outfile," %s",COLOUROPT1) == EOF) helpscrn(4);
    if (fprintf (outfile,"%-28s%8lu %s %s",c_name[0][c_index[0][0]],c_num[0][c_index[0][0]],COLOURBOXB,COLOUROPT2) == EOF) helpscrn(4);
    if (fprintf (outfile,"%-28s%8lu %s\r\n",c_name[1][c_index[1][0]],c_num[1][c_index[1][0]],COLOURBOXB) == EOF) helpscrn(4);
    }
  }
if (k == 6)
  {
  if (fprintf (outfile," %s",COLOUROPT1) == EOF) helpscrn(4);
  if (fprintf (outfile,"%-17s%6lu %s %s",c_name[0][c_index[0][0]],c_num[0][c_index[0][0]],COLOURBOXB,COLOUROPT2) == EOF) helpscrn(4);
  if (fprintf (outfile,"%-17s%6lu %s %s",c_name[1][c_index[1][0]],c_num[1][c_index[1][0]],COLOURBOXB,COLOUROPT3) == EOF) helpscrn(4);
  if (fprintf (outfile,"%-17s%6lu %s\r\n",c_name[2][c_index[2][0]],c_num[2][c_index[2][0]],COLOURBOXB) == EOF) helpscrn(4);
  }

// Output the remaining data
i = 1;
while (i < numtolist)
    {
    if (k == 1)
      {
      usr_time.ldate = c_call[c_index[0][i]];
      tm_now.tm_sec  = (int) usr_time.msg_st.time.ss;
      tm_now.tm_min  = (int) usr_time.msg_st.time.mm;
      tm_now.tm_hour = (int) usr_time.msg_st.time.hh;
      tm_now.tm_mday = (int) usr_time.msg_st.date.da;
      tm_now.tm_mon  = (int) usr_time.msg_st.date.mo - 1;
      tm_now.tm_year = (int) usr_time.msg_st.date.yr + 80;
      secs_now = mktime(&tm_now);
      tm_info = localtime(&secs_now);
      strftime(temp,80,"%Y %b %d  %H:%M:%S",tm_info);
      if (f_fc == 1)
        {
        strftime(temp,80,"%Y %b %d",tm_info);
        usr_time.ldate = c_fc[0][c_index[0][i]];
        tm_now.tm_sec  = (int) usr_time.msg_st.time.ss;
        tm_now.tm_min  = (int) usr_time.msg_st.time.mm;
        tm_now.tm_hour = (int) usr_time.msg_st.time.hh;
        tm_now.tm_mday = (int) usr_time.msg_st.date.da;
        tm_now.tm_mon  = (int) usr_time.msg_st.date.mo - 1;
        tm_now.tm_year = (int) usr_time.msg_st.date.yr + 80;
        secs_now = mktime(&tm_now);
        tm_info = localtime(&secs_now);
        strftime(temp1,80,"%Y %b %d",tm_info);
        if (c_name[0][c_index[0][i]][0] == '\0') temp1[0] = '\0';
        if (fprintf (outfile," %s",COLOURDATA) == EOF) helpscrn(4);
        if (fprintf (outfile,"%-34s%-15s%-16s%10lu %s\r\n",c_name[0][c_index[0][i]],temp1,temp,c_num[0][c_index[0][i]],COLOURBOXB) == EOF) helpscrn(4);
        }
      else
        {
        if (fprintf (outfile," %s",COLOURDATA) == EOF) helpscrn(4);
        if (fprintf (outfile,"%-40s%-25s%10lu %s\r\n",c_name[0][c_index[0][i]],temp,c_num[0][c_index[0][i]],COLOURBOXB) == EOF) helpscrn(4);
        }
      }
    if (k == 3)
      {
      if (f_fc == 1)
        {
        usr_time.ldate = c_fc[0][c_index[0][i]];
        tm_now.tm_sec  = (int) usr_time.msg_st.time.ss;
        tm_now.tm_min  = (int) usr_time.msg_st.time.mm;
        tm_now.tm_hour = (int) usr_time.msg_st.time.hh;
        tm_now.tm_mday = (int) usr_time.msg_st.date.da;
        tm_now.tm_mon  = (int) usr_time.msg_st.date.mo - 1;
        tm_now.tm_year = (int) usr_time.msg_st.date.yr + 80;
        secs_now = mktime(&tm_now);
        tm_info = localtime(&secs_now);
        strftime(temp,80,"%Y-%b-%d",tm_info);
        if (c_name[0][c_index[0][i]][0] == '\0') temp[0] = '\0';
        usr_time.ldate = c_fc[1][c_index[1][i]];
        tm_now.tm_sec  = (int) usr_time.msg_st.time.ss;
        tm_now.tm_min  = (int) usr_time.msg_st.time.mm;
        tm_now.tm_hour = (int) usr_time.msg_st.time.hh;
        tm_now.tm_mday = (int) usr_time.msg_st.date.da;
        tm_now.tm_mon  = (int) usr_time.msg_st.date.mo - 1;
        tm_now.tm_year = (int) usr_time.msg_st.date.yr + 80;
        secs_now = mktime(&tm_now);
        tm_info = localtime(&secs_now);
        strftime(temp1,80,"%Y-%b-%d",tm_info);
        if (c_name[1][c_index[1][i]][0] == '\0') temp1[0] = '\0';
        if (fprintf (outfile," %s",COLOURDATA) == EOF) helpscrn(4);
        if (fprintf (outfile,"%-17s%-11s%8lu %s %s",c_name[0][c_index[0][i]],temp,c_num[0][c_index[0][i]],COLOURBOXB,COLOURDATA) == EOF) helpscrn(4);
        if (fprintf (outfile,"%-17s%-11s%8lu %s\r\n",c_name[1][c_index[1][i]],temp1,c_num[1][c_index[1][i]],COLOURBOXB) == EOF) helpscrn(4);
        }
      else
        {
        if (fprintf (outfile," %s",COLOURDATA) == EOF) helpscrn(4);
        if (fprintf (outfile,"%-28s%8lu %s %s",c_name[0][c_index[0][i]],c_num[0][c_index[0][i]],COLOURBOXB,COLOURDATA) == EOF) helpscrn(4);
        if (fprintf (outfile,"%-28s%8lu %s\r\n",c_name[1][c_index[1][i]],c_num[1][c_index[1][i]],COLOURBOXB) == EOF) helpscrn(4);
        }
      }
    if (k == 6)
      {
      if (fprintf (outfile," %s",COLOURDATA) == EOF) helpscrn(4);
      if (fprintf (outfile,"%-17s%6lu %s %s",c_name[0][c_index[0][i]],c_num[0][c_index[0][i]],COLOURBOXB,COLOURDATA) == EOF) helpscrn(4);
      if (fprintf (outfile,"%-17s%6lu %s %s",c_name[1][c_index[1][i]],c_num[1][c_index[1][i]],COLOURBOXB,COLOURDATA) == EOF) helpscrn(4);
      if (fprintf (outfile,"%-17s%6lu %s\r\n",c_name[2][c_index[2][i]],c_num[2][c_index[2][i]],COLOURBOXB) == EOF) helpscrn(4);
      }
    i++;
    }

if (fprintf(outfile,"%s",d1) == EOF) helpscrn(4);      // Output box divider
sprintf(temp,"%77s"," ");
sprintf(temp1,"Prepared by %s (v%s)",RDS_TITLE,RDS_VERSION);
j = (strlen(temp) - strlen(temp1)) / 2;
i = 0;
while (temp1[i] != '\0')
  {
  temp[j] = temp1[i];
  j++;
  i++;
  }
if (fprintf(outfile,"%s%s%s\r\n",COLOURFOOT,temp,COLOURBOXB) == EOF) helpscrn(4);
sprintf(temp,"%77s"," ");
sprintf(temp1,"Copyright (c) Bob Swift, %s.  All Rights Reserved.",RDS_DATES);
j = (strlen(temp) - strlen(temp1)) / 2;
i = 0;
while (temp1[i] != '\0')
  {
  temp[j] = temp1[i];
  j++;
  i++;
  }
if (fprintf(outfile,"%s%s%s\r\n",COLOURFOOT,temp,COLOURBOXB) == EOF) helpscrn(4);

// Output lower box border
if (fprintf(outfile,"%s%s",COLOURBOXB,e1) == EOF) helpscrn(4);

// Press Enter prompt and CLS
if (fprintf(outfile,"%s",WHITE) == EOF) helpscrn(4);
if (f_ea == 1)
  {
  if (fputc(1,outfile) == EOF) helpscrn(4);
  }
if (fprintf(outfile,"%s",GRAY) == EOF) helpscrn(4);
if (f_ca == 1)
  {
  if (fputc(12,outfile) == EOF) helpscrn(4);
  }

/*  Close the destination file  */
fclose(outfile);

/*  Thank the user and exit gracefully  */
printf("\n\nOperation complete.  Thank-you for using %s.\n\n",RDS_TITLE);
exit(0);
}

/*******************************************************************/

void helpscrn(int ernum)
/*  Here are the error messages and VERY brief instructions  */
{
printf("\n\n");
switch (ernum) {

case  1 : printf("Bad / Extra command line argument.\n\n");
          break;

case  2 : printf("Unable to open the control file.\n\n");
          break;

case  3 : printf("Unable to read the input file.\n\n");
          break;

case  4 : printf("Unable to write the output file.\n\n");
          break;

case  5 : printf("No user records to process.\n\n");
          break;

    }

printf("This program is used to read the Max 3.00 USER.BBS file and generate a\n");
printf("file listing the top users (upload, download, calls) for the BBS.\n\n");
printf("The format for using this program is as follows:\n\n");
printf("                 %s [ctlfile]\n\n",RDS_TITLE);
printf("Where [ctlfile] is the path and name of the control file (default is\n");
printf("                MAXTOP.CTL in the current directory).\n\n");
printf("Examples:        %s c:\max\misc\topuser.cfg\n",RDS_TITLE);
printf("                 %s ctlfiles\maxtop.ctl\n",RDS_TITLE);
printf("                 %s\n\n",RDS_TITLE);

exit(ernum);
}

/*******************************************************************/

